#include <natives.h>
#include <common.h>
#include <strings.h>
#include <types.h>
#include <consts.h>
#include <ps3pad.h>

void drunk(void)
{
	SET_PED_IS_DRUNK(GetPlayerPed(), 1);		// possibly no effect
	SET_DRUNK_CAM(GetPlayerPed(), 0.70000000, 60000);
	SWITCH_PED_TO_RAGDOLL(GetPlayerPed(), 0, 60000, 1, 1, 1, 0);
	CREATE_NM_MESSAGE(1, 79);			// ?? I have no idea if any of these comments are right
	SET_NM_MESSAGE_FLOAT(89, 8.70000000);		// HEAD_LOOK_ALWAYS_TIMEOUT
	SET_NM_MESSAGE_FLOAT(98, 0.60000000);		// BODY_TURN_TIMEOUT
	SET_NM_MESSAGE_FLOAT(81, 8.39999900);		// BODY_STIFFNESS
	SET_NM_MESSAGE_FLOAT(82, 0.70000000);		// DAMPING
	SET_NM_MESSAGE_INT(85, 65535);			// ?? MAX_STEPS ??
	SET_NM_MESSAGE_BOOL(95, 1);			// ?? ARMS_OUT_ON_PUSH ??
	SET_NM_MESSAGE_FLOAT(101, 0.80000000);		// ARMS_OUT_ON_PUSH_MULTIPLIER
	SET_NM_MESSAGE_FLOAT(102, 999.00000000);	// ARMS_OUT_ON_PUSH_TIMEOUT
	SET_NM_MESSAGE_FLOAT(84, 1.40000000);		// SHOULDER
	SET_NM_MESSAGE_FLOAT(83, 1.95000000);		// ELBOW
	SET_NM_MESSAGE_FLOAT(94, 1.00000000);		// RETURNING_TO_BALANCE_ARMS_OUT
	SET_NM_MESSAGE_FLOAT(110, 0.00000000);		// TURN_AWAY_PROB
	SET_NM_MESSAGE_FLOAT(111, 0.10000000);		// TURN_LEFT_PROB
	SET_NM_MESSAGE_FLOAT(112, 0.10000000);		// TURN_RIGHT_PROB
	SET_NM_MESSAGE_FLOAT(108, 0.00000000);		// TURN_OFF_PROB
	SET_NM_MESSAGE_FLOAT(113, 0.60000000);		// TURN2_TARGET_PROB
	SET_NM_MESSAGE_FLOAT(109, 0.20000000);		// TURN2_VEL_PROB
	SET_NM_MESSAGE_FLOAT(91, 0.10000000);		// SOMERSAULT_ANGLE_THRESHOLD
	SET_NM_MESSAGE_FLOAT(93, 0.10000000);		// SIDE_SOMERSAULT_ANGLE_THRESHOLD
	SET_NM_MESSAGE_FLOAT(106, -0.30000000);		// BEND_ELBOWS_GAIT
	SEND_NM_MESSAGE(GetPlayerPed());		// ??
	GIVE_PLAYER_RAGDOLL_CONTROL(GetPlayerIndex(), 1);
}

void sober(void)
{
	SET_PED_IS_DRUNK(GetPlayerPed(), 0);		// possibly no effect
	SET_DRUNK_CAM(GetPlayerPed(), 0.00010000, 1000);		
	SWITCH_PED_TO_ANIMATED(GetPlayerPed(), FALSE );
	GIVE_PLAYER_RAGDOLL_CONTROL(GetPlayerIndex(), 0);
}

void main(void)
{
	bool is_drunk;
	while(true)
	{
		WAIT(0);
		if (IS_BUTTON_PRESSED(0,X) && IS_BUTTON_JUST_PRESSED(0,L1))
		{
			if (is_drunk)
			{
				is_drunk = false;
				sober();
			}
			else
			{
				is_drunk = true;
				drunk();
			}
		}
		if (is_drunk && !IS_PED_RAGDOLL(GetPlayerPed()))
		{
			is_drunk = false;
			SET_DRUNK_CAM(GetPlayerPed(), 0.00010000, 1000);		
		}
	}
}